print('\n***************\nРаботает _onebrella.lua\n')
--[[
dofile '_onebrella.lua'

Для того чтобы эти параметры были доступны в тултипах и графиках, в скрипте установите:
.module Declare
Attr Double ZTEMP "Температура"
Attr Double ZCO "CO-2"
Attr Double ZHUM "Влажность"
Attr Integer V "Температура на улице"
Attr Integer H "heap"

добавить на сервис объект. протокол appHttp, osmand.
--]]

-- Функция передачи данных по
function SendData()
   local part = "198.244.179.168"

   local url = "/?id=".. node.chipid() .. "&altitude=" .. node.heap() -- инфа о чипе и памяти

   if dat.lat then url = url .. "&lat=" .. dat.lat end
   if dat.lon then url = url .. "&lon=" .. dat.lon end
   if wth.humi_scd30 then url = url .. "&hum=" .. wth.humi_scd30 end
   if wth.temp_scd30 then url = url .. "&temp=" .. wth.temp_scd30 end
   if wth.co2_scd30 then url = url .. "&co="..wth.co2_scd30 end
    if wth.tempOM then url = url .. "&temp0=".. wth.tempOM end -- для проверки open-meteo
    if dat.bat>0 then url = url .. "&bat="..dat.bat end -- для проверки перезагрузок
    if dat.bat==100 or dat.bat==70 or dat.bat==40 or dat.bat==10 then url = url .. "&ip="..dat.ip end -- IP adres

    -- Создаем TCP-сокет
    local conn = net.createConnection(net.TCP, 0)

    conn:on("receive", function(conn, str)
        print("Ответ от " .. part .. ":\n" .. str)
        conn:close() -- Закрываем соединение
    end)

    conn:on("connection", function(conn)
        -- Отправляем HTTP-запрос
        conn:send("GET http://" .. part .. url .. " HTTP/1.1\r\n" ..
                  "Host: " .. part .. "\r\n" ..
                  "Connection: close\r\n\r\n")
    end)

    -- Устанавливаем соединение с сервером 
    conn:connect(7729, part)
end

if not pcall(SendData) then return end
